Attribute VB_Name = "z_UIMessages"
' Messaging module
Option Private Module
Option Explicit

Public Enum MsgCode
  EM_TABLE_NOT_SELECTED
  EM_TABLE_MERGED_CELLS
  EM_TABLE_OUTSIDE_SECTION
  EM_INVALID_CONTENTS_TABLE
  EM_CANNOT_INSERT_IMAGE
  EM_FIX_LINING_FAIL
  EM_INVALID_TABLE_COLUMNS
  
  IM_AUTODESIGN_OK
  IM_FIX_LINES_OK
  IM_REPAINT_OK
  IM_FOOTER_OK
  IM_FIX_BOOKMARK_NAME
End Enum

Private g_UI As API_UserInteraction

Public Function UserInteraction() As API_UserInteraction
  If g_UI Is Nothing Then _
    Set g_UI = New API_UserInteraction
  Set UserInteraction = g_UI
End Function

Public Function SetUserInteraction(newUI As API_UserInteraction)
  Set g_UI = newUI
End Function

Public Function UIShowMessage(theCode As MsgCode, ParamArray params() As Variant)
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Select Case theCode
  Case EM_TABLE_NOT_SELECTED:     Call MsgBox(" !", vbExclamation)
  Case EM_TABLE_MERGED_CELLS:     Call MsgBox("      ", vbCritical)
  Case EM_TABLE_OUTSIDE_SECTION:  Call MsgBox("    ", vbExclamation)
  Case EM_INVALID_CONTENTS_TABLE: Call MsgBox("   !  !", vbExclamation)
  Case EM_CANNOT_INSERT_IMAGE:    Call MsgBox("   !", vbCritical)
  Case EM_FIX_LINING_FAIL:        Call MsgBox("   ,   !", vbCritical)
  Case EM_INVALID_TABLE_COLUMNS:  Call MsgBox("   2 ", vbCritical)
    
  Case IM_AUTODESIGN_OK:          Call MsgBox(" ", vbInformation)
  Case IM_FIX_LINES_OK:           Call MsgBox("   ", vbInformation)
  Case IM_REPAINT_OK:             Call MsgBox("  !", vbInformation)
  Case IM_FOOTER_OK:              Call MsgBox("   !", vbInformation)
  Case IM_FIX_BOOKMARK_NAME:      Call MsgBox(Fmt(" ,   {1}", unwrapped), vbInformation)
  
  Case Else:                      Call MsgBox("  ", vbCritical)
  End Select
End Function

Public Function UIAskQuestion(theCode As MsgCode, ParamArray params() As Variant) As Boolean
  Dim unwrapped As Variant: unwrapped = params
  unwrapped = FixForwardedParams(unwrapped)
  
  Dim answer&: answer = vbNo
  Select Case theCode
'  Case QM_CODE_DELETE_CONFIRM
'    answer = MsgBox("Are you sure you want to delete ALL macros from target file?", vbYesNo + vbQuestion)
    
  Case Else
    Call MsgBox("  ", vbCritical)
  End Select
  UIAskQuestion = answer = vbYes
End Function
